#include "Quadrature.hpp"


namespace Fem3D  //=========================================================================
{

Quadrature2DPoint Formula2D_3PointsAxisymetrie[] = {
    {1./6., 1./6.,    1./6.},
    {2./3., 1./6.,    1./6.},
    {1./6., 2./3.,    1./6.}
};

#define SQRT15 (3.87298334620741688517926539978)
#define _wa ( ( 155.-SQRT15 )/2400. )
#define _wb ( ( 155.+SQRT15 )/2400. )
#define _da ( ( 6.-SQRT15 )/21. )
#define _db ( ( 9.+2.*SQRT15 )/21. )
#define _dc ( ( 6.+SQRT15 )/21. )
#define _dd ( ( 9.-2.*SQRT15 )/21. )
Quadrature2DPoint Formula2D_7Points[] = {
    { _da, _da,       _wa },
    { _da, _db,       _wa },
    { _db, _da,       _wa },
    { _dc, _dc,       _wb },
    { _dc, _dd,       _wb },
    { _dd, _dc,       _wb },
    { 1./3., 1./3., 9./80. },
};


Quadrature3DPoint Formula3D_4Points[] = {
    {0., 0., 0.,   1./24.},
    {1., 0., 0.,   1./24.},
    {0., 1., 0.,   1./24.},
    {0., 0., 1.,   1./24.}
};


#define _d1 ((7.-SQRT15)/34.)
#define _d2 ((13.+3.*SQRT15)/34.)
#define _d3 ((7.+SQRT15)/34.)
#define _d4 ((13.-3.*SQRT15)/34.)
#define _d5 ((10.-2*SQRT15)/40.)
#define _d6 ((10.+2*SQRT15)/40.)
#define _w1 ((2665.+14.*SQRT15)/226800)
#define _w2 ((2665.-14.*SQRT15)/226800)
#define _w3 (5./567.)
Quadrature3DPoint Formula3D_15Points[] = {
    {1./4.,1./4.,1/4., 8./405.},
    {_d1, _d1, _d1,   _w1},
    {_d2, _d1, _d1,   _w1},
    {_d1, _d2, _d1,   _w1},
    {_d1, _d1, _d2,   _w1},

    {_d3, _d3, _d3,   _w2},
    {_d4, _d3, _d3,   _w2},
    {_d3, _d4, _d3,   _w2},
    {_d3, _d3, _d4,   _w2},

    {_d5, _d6, _d6,   _w3},
    {_d6, _d5, _d5,   _w3},
    {_d6, _d6, _d5,   _w3},
    {_d5, _d5, _d6,   _w3},
    {_d5, _d6, _d5,   _w3},
    {_d6, _d5, _d6,   _w3},
};



#if 0
typedef struct { R x,y; R poids; } truc;
typedef struct { 
	int n;
	int pUnisolvant;  // contient le degre
	int pIntegre;  // contient le degre
	truc *points;
} Bidules;


Bidules adsf = {
	n=3,
	pUnisolvant=1,
	pIntegre=1,
	points= {
	    {1./6., 1./6.,    1./6.},
	    {2./3., 1./6.,    1./6.},
	    {1./6., 2./3.,    1./6.}
	}
};


#endif


} // namespace

