
R TetaExact ( R3 & P ) { return 10.; }
R fOmega( R3 & P) { return  0.; }
/#define UDirichlet TetaExact
#endif

#if 0
//// On prends l'exemple de teta(x,y) = x*y - 2*x*z - y : ok
#define isDirichlet(x) ((x)>0 && (x)<7) // de 1 a 6 inclus
#define isRobin(x)     (false )
#define isNeumann(x)   (false )
#define MESHFILE "hexaedre.msh"

R TetaExact ( R3 & P ) { return 10*( P.x*P.y-2*P.x*P.z-P.y ); }
R fOmega( R3 & P) { return  0.; }
#define UDirichlet TetaExact
#endif

#if 0
//// On prends l'exemple de teta(x,y) = x(1-x)y(1-y)z(1-z)
//// pratique pour tester 0 au bord et laplacien non nul
#define isDirichlet(x) ((x)>0 && (x)<7) // de 1 a 6 inclus
#define isRobin(x)     (false )
#define isNeumann(x)   (false )
#define MESHFILE "hexaedre.msh"

R TetaExact ( R3 & P ) { return 128*P.x*(1-P.x)*P.y*(1-P.y)*P.z*(1-P.z); }
R fOmega( R3 & P) { return  128*2*
	( P.y*(1-P.y)*P.z*(1-P.z) + P.x*(1-P.x)*P.z*(1-P.z) + P.x*(1-P.x)*P.y*(1-P.y )) ;}
R UDirichlet(  R3 &P ) { return 0.; }
#endif


#if 0
// une fonction quelconque de laplacien non constant et non constante au bord
#  define isDirichlet(x) ((x)==1 || (x)==5)
#  define isNeumann(x)   ((x)==2 || (x)==3)
#  define isRobin(x)     ((x)==4 || (x)==6)
//#  define isDirichlet(x) ((x)==1 || (x)==3 || (x)==4 || (x)==5)
//#  define isNeumann(x)   ((x)==2 || (x)==6 )
//#  define isRobin(x)     (false )
#define MESHFILE "hexaedre.msh"

R TetaExact ( R3 & P ) { return 10*(2*P.x*P.y*P.z-10*P.y*P.x*P.x+6*P.z*P.z*P.x); }
R3 GradF ( R3 & P ) { return 10*R3(
			2*P.y*P.z-20*P.y*P.x  +6*P.z*P.z,
			2*P.x*P.z-10*P.x*P.x  ,
			2*P.x*P.y             +12*P.x*P.z ); }
R fOmega( R3 & P) { return  10*(20*P.y-12*P.x); }
#define UDirichlet TetaExact
R UNeumann(  R3 & P, Label l) {
	return (GradF(P), normale(l));
}

#define TetaRobin ( 300. )
R TetaExtRobin( R3 & P ) { return TetaRobin; } // temperature exterieur, frontiere de Robin
R GRobin( R3 & P , Label l) { // coefficient d'echange pour la frontiere de Robin
	// la, on triche :)
	return UNeumann( P,l ) /( TetaExtRobin( P )-TetaExact( P ) );
}

#endif

#if 0
//// exemple plus realiste....
////
/*
 * Labels:
 */
//  hexaedre.msh :
//        2   {est le NUMERO ou LABEL dans SURFACE    de } HAUT
//        6   {est le NUMERO ou LABEL dans SURFACE    de } DROITE
//        4   {est le NUMERO ou LABEL dans SURFACE    de } DEVANT
//        5   {est le NUMERO ou LABEL dans SURFACE    de } GAUCHE
//        3   {est le NUMERO ou LABEL dans SURFACE    de } DERRIERE
//        1   {est le NUMERO ou LABEL dans SURFACE    de } BASE
#if 1
#  define isDirichlet(x) ((x)==1 || (x)==1 || (x)==5)
#  define isNeumann(x)   ((x)==2 || (x)==3)
#  define isRobin(x)     ((x)==4 || (x)==6)
#  else
#  define isDirichlet(x) ((x)==1 || (x)==3 || (x)==4 || (x)==5)
#  define isNeumann(x)   ((x)==2 || (x)==6 )
#  define isRobin(x)     (false )
//#  define isNeumann(x)   (false )
//#define isDirichlet(x) ((x)>0 && (x)<7) // de 1 a 6 inclus
#endif
#define MESHFILE "hexaedre.msh"


// on prends l'exemple de teta(x,y) = x*x + y*y + z*z

#define UDirichlet TetaExact
R TetaExact ( R3 & P ) { return P.x*P.x + P.y*P.y + P.z*P.z; }
R fOmega( R3 & P) { return  -6.;} // laplacien constant = 6

R UNeumann(  R3 & P, Label l) {
	// le gradient vaut 2*P, et donc la derivee normale (grad,n)
	return 2*(P, normale( l ));
}

#define TetaRobin ( 20. )
#define G  ( 1. )
R TetaExtRobin( R3 & P ) { return TetaRobin; } // temperature exterieur, frontiere de Robin
R GRobin( R3 & P , Label l) { // coefficient d'echange pour la frontiere de Robin
	// la, on triche :)
	return UNeumann( P,l ) /( TetaExtRobin( P )-TetaExact( P ) );
}
#endif



#if 1
// l'exemple de comparaison avec les autres
/*
 * Labels:
 */
//  hexaedre.msh :
//        2   {est le NUMERO ou LABEL dans SURFACE    de } HAUT
//        6   {est le NUMERO ou LABEL dans SURFACE    de } DROITE
//        4   {est le NUMERO ou LABEL dans SURFACE    de } DEVANT
//        5   {est le NUMERO ou LABEL dans SURFACE    de } GAUCHE
//        3   {est le NUMERO ou LABEL dans SURFACE    de } DERRIERE
//        1   {est le NUMERO ou LABEL dans SURFACE    de } BASE
#if 1
#  define isDirichlet(x) ((x)>=1 && (x)<=6)
#  define isNeumann(x)   (false)
#  define isRobin(x)   (false)
#  else
#  define isDirichlet(x) ((x)>=2 && (x)<=6)
#  define isNeumann(x)   ((x)==1)
#  define isRobin(x)     (false )
//#  define isNeumann(x)   (false )
//#define isDirichlet(x) ((x)>0 && (x)<7) // de 1 a 6 inclus
#endif
#define MESHFILE "hexaedre.msh"


// on prends l'exemple de teta(x,y) = x*x + y*y + z*z

#define UDirichlet TetaExact
R TetaExact ( R3 & P ) { return P.x*P.x + P.y*P.y + P.z*P.z; }
R fOmega( R3 & P) { return  -6.;} // laplacien constant = 6

R UNeumann(  R3 & P, Label l) {
	// le gradient vaut 2*P, et donc la derivee normale (grad,n)
	return 2*(P, normale( l ));
}

#define TetaRobin ( 20. )
#define G  ( 1. )
R TetaExtRobin( R3 & P ) { return TetaRobin; } // temperature exterieur, frontiere de Robin
R GRobin( R3 & P , Label l) { // coefficient d'echange pour la frontiere de Robin
	// la, on triche :)
	return UNeumann( P,l ) /( TetaExtRobin( P )-TetaExact( P ) );
}
#endif
