//Fichier Laplace.cpp modifie par Alain Perronnet
// a partir de l'original ecrit par Frederic HECHT  fem-v5/Laplace1.cpp
//------------------------------------------------------------------------------

//Resolution du Laplacien : Solution exacte U(x,y)=3*x+5*y

//------------------------------------------------------------------------------

int verbosity =2;        //Definit le niveau des impressions

#include <cmath>
#include <cstdlib>
#include <cassert>
#include <iostream>
#include <fstream>       //pour lire le fichier de maillage

#include "rgraph.hpp"    //pour les traces
using namespace std;  

#include "throwassert.hpp"
#include "MatriceCreuse_tpl.hpp"   //pour la matrice globale EF profil

using namespace Fem3D;


int main(int argc, char **argv)
{
  R3 h;
  Vertex vertices[8] = {
  };

  (vertices[0]).set(0.,0.,0.);
  (vertices[1]).set(1.,0.,0.);
  (vertices[2]).set(0.,1.,0.);
  (vertices[3]).set(0.,0.,1.);
  (vertices[4]).set(.5,.5,1);
  (vertices[5]).set(1.,1.,1.);

// should fault :   Tetraedre tbad(vertices,0,1,3,2,0);
  Tetraedre t(vertices,0,1,2,3,0); // label=0; we dont care here


  cout << endl << "First exemple " <<endl;
  h = t.H(0); cout << "Hauteur 0 : " << h << endl;
  cout <<             "should be : -0.333333 -0.333333 -0.333333"<< endl;
  h = t.H(1); cout << "Hauteur 1 : " << h << endl;
  cout <<             "should be : 1,0,0" << endl;
  h = t.H(2); cout << "Hauteur 2 : " << h << endl;
  cout <<             "should be : 0,1,0" << endl;
  h = t.H(3); cout << "Hauteur 3 : " << h << endl;
  cout <<             "should be : 0,0,1" << endl;
  cout << "volume    : " << t.volume << endl;
  cout << "should be : 0.1666" << endl << endl;


  cout << endl << "second exemple " <<endl;
  t.set(vertices,0,1,2,4,0); // label=0; we dont care here
  h = t.H(0); cout << "Hauteur 0 : " << h << endl;
  cout <<             "should be :  -0.5 -0.5 0"<< endl;
  h = t.H(1); cout << "Hauteur 1 : " << h << endl;
  cout <<             "should be : 0.8 -0 -0.4" << endl;
  h = t.H(2); cout << "Hauteur 2 : " << h << endl;
  cout <<             "should be : 0 0.8 -0.4" << endl;
  h = t.H(3); cout << "Hauteur 3 : " << h << endl;
  cout <<             "should be : 0,0,1" << endl;
  cout << "volume    : " << t.volume << endl;
  cout << "should be : 0.1666" << endl << endl;

  cout << endl << "3eme exemple " <<endl;
  t.set(vertices,1,2,3,5,0); // label=0; we dont care here
  h = t.H(0); cout << "Hauteur 0 : " << h << endl;
  cout <<             "should be : 0.666667 -0.666667 -0.666667"<< endl;
  h = t.H(1); cout << "Hauteur 1 : " << h << endl;
  cout <<             "should be : -0.666667 0.666667 -0.666667" << endl;
  h = t.H(2); cout << "Hauteur 2 : " << h << endl;
  cout <<             "should be : -0.666667 -0.666667 0.666667" << endl;
  h = t.H(3); cout << "Hauteur 3 : " << h << endl;
  cout <<             "should be : 0.666667 0.666667 0.666667" << endl;
  cout << "volume    : " << t.volume << endl;
  cout << "should be : 0.333333" << endl << endl;




   
  return 0;
}
